var Version = "1.0.5";

// 初始化页面
window.homeView = F7.addView('#homeView', {
    domCache: true
});

//数据库全局变量
var db;

//地址
var loc = '';

//全局变量存储设备唯一id
var device_uuid = '';

// 定义模型类
var Model = avalon.vmodels;

//web端使用webSql数据库
if (openDatabase) {
    db = openDatabase('DataBase', '1.0', 'data', 2 * 1024 * 1024);
    getHistoryNum();
}
//创建数据库并判断数据数量
function getHistoryNum() {
    db.transaction(function (tx) {
        //tx.executeSql('DROP TABLE IF EXISTS DATAS');
        tx.executeSql('CREATE TABLE IF NOT EXISTS DATAS (bill_number, bill_key, device_id, interval, total, max_t, min_t, start_time, end_time, mail, datas, uuid PRIMARY KEY, device_name, model, param, status, bill_time, read_time)');
        tx.executeSql('SELECT COUNT(*) AS C FROM DATAS', [], function (tx, r) {
            var historyNum = r.rows.item(0).C;
            if (historyNum > 0) {
                homeAv.showHistory = true;
            }
        });
    });
}

// android
if (App.android) {
    var exitSure = false;
    // 物理返回键事件
    document.addEventListener("backbutton", function () {
        var backBtn = $$(document).find(".left .back");
        var bleBack = $$(document).find(".page-on-center .J_bleDetailsBack");
        if (exitSure) {
            navigator.app.exitApp();
        } else {
            if (homeView.url == '#index') {
                exitSure = true;
                App.toast('再按一次退出系统');
                setTimeout(function () {
                    exitSure = false;
                }, 2000)
            } else {
                if (bleBack.length > 0) {
                    $$(".page-on-center .J_bleDetailsBack").trigger('click');
                    return false;
                }
                if (backBtn.length > 0) {
                    homeView.router.back();
                    return false;
                }
            }
        }


    }, false);
}

//设备启动完成后立即运行
document.addEventListener("deviceready", function () {
    device_uuid = device.uuid;
    // 隐藏启动页面
    navigator.splashscreen.hide();
    //打开sqLite数据库
    db = window.sqlitePlugin.openDatabase({name: "data.db", location: 'default'});
    getHistoryNum();

    //获取地理位置
    navigator.geolocation.getCurrentPosition(function (position) {
        loc = position.coords.latitude + ',' + position.coords.longitude;
    }, function (error) {
        console.log('code: ' + error.code + '\n' + 'message: ' + error.message + '\n');
    });
}, false);

// 登录页面加载成功事件 检查更新 
avalon.ready(function () {
    if (App.android) {
        Service.update(function (data) {
            if (App.compareVersion(data.version, Version) > 0) {
                App.confirm(data.log, '发现新版本' + data.version, function () {
                    cordova.InAppBrowser.open(data.url, '_system', 'location=yes');
                }, function () {
                }, '暂不更新', '立即更新');
            }
        });
    }
});


//主页
var homeAv = avalon.define({
    $id: "homeCtl",
    num: '',               //输入框
    showHistory: false,    //是否显示历史记录
    data: {},              //存储设备数据
    base64: '',            //存储蓝牙历史数据
    tempData: {},          //存储蓝牙温度数据
    continue: true,        //蓝牙温度数据获取状态
    cfgData: {},           //蓝牙设备信息
    currentPeripheral: '', //存储正在连接的设备peripheral
    version: Version,      //版本号
    isConfirm: 0,          //避免频繁点击
    isScan: 0,          //避免频繁点击
    confirm: function () {
        if (homeAv.isConfirm != 0) {
            return;
        }
        homeAv.isConfirm = 1;
        setTimeout(function () {
            homeAv.isConfirm = 0;
        }, 2000);
        // 清空缓存数据
        homeAv.data = {};
        homeAv.base64 = '';
        homeAv.tempData = {};
        homeAv.cfgData = {};
        var homeAvNum = homeAv.num;
        if (homeAvNum.indexOf('*') > -1) {
            homeAvNum = homeAvNum.replace(/\*/g, '');
        }
        if (homeAvNum == '' || homeAvNum == null) {
            App.alert('请扫码或输入序列号');
            return;
        }
        if (homeAvNum.length != 8) {
            App.preloader.show("正在获取单据相关信息");
            Service.getLatestBind(homeAvNum, function (ret) {
                homeAvNum = ret.device_id;
                getDeviceInfo(homeAvNum, ret.at);
            }, function (e) {
                App.preloader.hide();
                App.alert("绑定信息获取失败")
            })
        } else {
            getDeviceInfo(homeAvNum);
        }
        function getDeviceInfo(homeAvNum, bindTime) {
            if (/^[A-Z0-9]+$/.test(homeAvNum)) {
                //蓝牙设备本地化操作
                if (homeAvNum.indexOf('BT') > -1 || homeAvNum.indexOf('SLTH') > -1) {
                    App.preloader.show("正在搜索蓝牙温度记录仪" + '</br>' +
                        "设备编号:" + homeAvNum, 1000 * 60 * 4);
                    // 设置扫描超时，扫描成功后把定时器清掉
                    var scanTimer = setTimeout(function () {
                        Dxsdk.sys.stopScan(function () {
                            homeAv.isScan = 0;
                        });
                        clearTimeout(connectTimer);
                        App.preloader.hide();
                        App.alert("扫描失败");
                    }, 10000);
                    var connectTimer = setTimeout(function () {
                        App.preloader.hide();
                        App.alert("连接超时，请稍后重试");
                    }, 20000);
                    //扫描匹配名称
                    Dxsdk.sys.startScan([], function (device) {
                        if (homeAvNum == device.name) {
                            clearTimeout(scanTimer);
                            Dxsdk.sys.stopScan(function () {
                                //先停止扫描设备然后连接
                                var deviceId = device.id;
                                $$('.modal-title').text('正在连接设备:' + homeAvNum);
                                //连接并获取peripheral
                                Dxsdk.sys.connect(deviceId, function (peripheral) {
                                    homeAv.currentPeripheral = peripheral;
                                    clearTimeout(connectTimer);

                                    Dxsdk.api.syncTime(homeAv.currentPeripheral, function () {
                                        //获取设备型号信息,根据型号取数据解析方案
                                        Dxsdk.api.cfgFixed(homeAv.currentPeripheral, function (cfgFixedData) {
                                            var version = cfgFixedData.ver.split('.')[0];
                                            if (version != 'V1' && version != '630' && version != '640' && version != '640+') {
                                                App.preloader.hide();
                                                disconnectDevice(homeAv.currentPeripheral);
                                                App.alert('暂不支持此设备');
                                                return;
                                            }

                                            if (version == '640+') {
                                                Dxsdk.api.closeDevice(homeAv.currentPeripheral, function () {
                                                    nextStep();
                                                    //获取设备基本信息
                                                }, function () {
                                                    App.preloader.hide();
                                                    disconnectDevice(homeAv.currentPeripheral);
                                                    App.alert("设备命令发送失败，请返回后重新连接");
                                                })
                                            } else {
                                                nextStep();
                                            }

                                            function nextStep() {
                                                Dxsdk.api.cfg(homeAv.currentPeripheral, function (data) {
                                                    homeAv.cfgData = data;

                                                    if (!homeAv.cfgData || !homeAv.cfgData['logInterval']) {
                                                        App.preloader.hide();
                                                        disconnectDevice(homeAv.currentPeripheral);
                                                        App.alert('设备信息获取失败,请重试')
                                                    }

                                                    //获取温度数据
                                                    homeAv.continue = false;
                                                    Dxsdk.api.currentData(homeAv.currentPeripheral, function (data) {
                                                        homeAv.continue = true;
                                                        homeAv.tempData = data;
                                                        homeAv.tempData.time = App.formatDate(homeAv.tempData.time * 1000);

                                                        var dataNum = homeAv.tempData['num'];
                                                        var tick = homeAv.tempData['tick'];
                                                        if (!dataNum) {
                                                            App.preloader.hide();
                                                            disconnectDevice(homeAv.currentPeripheral);
                                                            App.alert('当前历史记录条数为空，无法获取');
                                                        } else {
                                                            var logTime = homeAv.tempData['logTime'];
                                                            var logInterval = homeAv.cfgData['logInterval'];
                                                            $$('.modal-title').text("正在同步数据:" + homeAvNum);
                                                            window.plugins.insomnia.keepAwake();
                                                            var continueTime = setInterval(function () {
                                                                if (homeAv.continue) {
                                                                    clearInterval(continueTime);
                                                                    var timeNow = Date.parse(new Date()) / 1000;
                                                                    homeAv.tempData['logTime'] = timeNow;
                                                                    var totalPackage = 0;

                                                                    //android环境下读取数据异常处理,暂时加一秒延迟
                                                                    setTimeout(function () {
                                                                        Dxsdk.api.historyData(peripheral, version, function (data, base64) {
                                                                            homeAv.base64 = base64;
                                                                            var dataLength = data.length;
                                                                            if (!tick) {
                                                                                // 判断最新记录时间是否比当前时间快或者慢一天
                                                                                if (1 > (homeAv.tempData['logTime'] - (logTime + logInterval * (dataLength - 1))) || (homeAv.tempData['logTime'] - (logTime + logInterval * (dataLength - 1))) > 2592000) {
                                                                                    logTime = homeAv.tempData['logTime'] - logInterval * (dataLength - 1);
                                                                                }
                                                                            } else {
                                                                                logTime = timeNow - tick;
                                                                            }
                                                                            var tmax = App.fmtNumber(Math.max.apply(null, data));
                                                                            var tmin = App.fmtNumber(Math.min.apply(null, data));
                                                                            var endtime = logTime + logInterval * (dataLength - 1);
                                                                            if (!tmax || !tmin || !logTime || !endtime) {
                                                                                App.preloader.hide();
                                                                                App.alert('温度统计数据获取失败,请重试');
                                                                                return;
                                                                            }

                                                                            //蓝牙数据处理
                                                                            homeAv.data.tmax = tmax;
                                                                            homeAv.data.tmin = tmin;
                                                                            homeAv.data.starttime = logTime;
                                                                            homeAv.data.endtime = endtime;
                                                                            homeAv.data.name = '未命名';
                                                                            if (version == 630 || version == 640 || version == '640+') {
                                                                                homeAv.data.model = 'DX0B' + version;
                                                                            } else {
                                                                                homeAv.data.model = 'DX0B610';
                                                                            }
                                                                            homeAv.data.uuid = device_uuid + Date.parse(new Date()) / 1000;
                                                                            // 清空保存的currentPeripheral
                                                                            window.plugins.insomnia.allowSleepAgain();
                                                                            homeAv.currentPeripheral = '';

                                                                            App.preloader.hide();
                                                                            homeView.router.loadPage('view/print.html?deviceId=' + homeAvNum);

                                                                        }, function (errorMsg) {
                                                                            window.plugins.insomnia.allowSleepAgain();
                                                                            // 异常时断开设备
                                                                            disconnectDevice(homeAv.currentPeripheral);
                                                                            App.preloader.hide();
                                                                            App.alert("温度历史数据获取失败，请返回后重新连接");
                                                                        }, function (progress) {
                                                                            if (totalPackage < progress.num) {
                                                                                totalPackage = progress.num + 1;
                                                                            }
                                                                            var per = parseInt((totalPackage - progress.num) * 100 / totalPackage);
                                                                            if (progress.num == 0) {
                                                                                per = 100;
                                                                            }
                                                                            $$('.modal-title').text("正在同步数据" + per + '%');
                                                                        });
                                                                    }, F7.device.android ? 1000 : 0)
                                                                }
                                                            }, 500);
                                                        }

                                                    }, function (errorMsg) {
                                                        App.preloader.hide();
                                                        disconnectDevice(homeAv.currentPeripheral);
                                                        App.alert("温度数据获取失败，请返回后重新连接");
                                                    });
                                                }, function (errorMsg) {
                                                    App.preloader.hide();
                                                    disconnectDevice(homeAv.currentPeripheral);
                                                    App.alert("基本信息获取失败，请返回后重新连接");
                                                });
                                            }
                                        }, function (errorMsg) {
                                            App.preloader.hide();
                                            disconnectDevice(homeAv.currentPeripheral);
                                            App.alert("设备固件信息获取失败，请返回后重新连接");
                                        });
                                    }, function () {
                                        App.preloader.hide();
                                        disconnectDevice(homeAv.currentPeripheral);
                                        App.alert("同步失败，请返回重试");
                                    })

                                }, function () {
                                    clearTimeout(connectTimer);
                                    App.preloader.hide();
                                    App.alert("设备连接失败,请重试")
                                }, function () {
                                    clearTimeout(connectTimer);
                                    App.preloader.hide();
                                    App.alert('连接中断，请返回后重新连接');
                                });
                            })
                        }
                    }, function (ret) {
                        if (ret == false) {
                            clearTimeout(scanTimer)
                        }
                    });
                } else {
                    App.preloader.show("正在获取设备数据" + '</br>' +
                        "设备编号:" + homeAvNum);
                    if (!bindTime) {
                        Service.getDeviceInfo(homeAvNum, function (ret) {
                            App.preloader.hide();
                            if (ret.code) {
                                if (ret.code == 206) {
                                    App.alert('设备不存在');
                                } else {
                                    App.alert('获取数据失败,请重试');
                                }
                            } else {
                                if (ret.model == "DX0B802" || ret.model == "DX0B801") {
                                    if (ret.total == 0) {
                                        App.alert('设备暂无数据，请稍后再试');
                                        return;
                                    }
                                    homeAv.data = ret;
                                    homeView.router.loadPage('view/print.html?deviceId=' + homeAvNum);
                                } else {
                                    App.alert('暂不支持此设备');
                                }
                            }
                        }, function (ret) {
                            App.preloader.hide();
                            App.alert(ret);
                        })
                    } else {
                        Service.getBindDeviceInfo(homeAvNum, bindTime, function (ret) {
                            App.preloader.hide();
                            if (ret.code) {
                                if (ret.code == 206) {
                                    App.alert('设备不存在');
                                } else {
                                    App.alert('获取数据失败,请重试');
                                }
                            } else {
                                if (ret.model == "DX0B802" || ret.model == "DX0B801") {
                                    if (ret.total == 0) {
                                        App.alert('设备暂无数据，请稍后再试');
                                        return;
                                    }
                                    homeAv.data = ret;
                                    homeView.router.loadPage('view/print.html?deviceId=' + homeAvNum);
                                } else {
                                    App.alert('暂不支持此设备');
                                }
                            }
                        }, function (ret) {
                            App.preloader.hide();
                            App.alert(ret);
                        })
                    }
                }
            } else {
                App.alert('序列号有误,请重新输入');
            }
        }
    },
    toUpperCase: function () {
        homeAv.num = App.trim(homeAv.num.toUpperCase());
    },
    scan: function () {
        if (homeAv.isScan != 0) {
            return;
        }
        homeAv.isScan = 1;
        setTimeout(function () {
            homeAv.isScan = 0;
        }, 5000);
        cordova.plugins.barcodeScanner.scan(
            function (result) {
                //alert(result.cancelled);
                if (!result.cancelled) {
                    homeAv.num = result.text;
                    homeAv.confirm();
                }
            },
            function (error) {
                App.alert("扫描失败，请重试");
            },
            {
                "preferFrontCamera": false, // iOS and Android
                "showFlipCameraButton": false, // iOS and Android
                "prompt": "请按音量键打开/关闭闪光灯" // supported on Android only
            }
        );
    },
    clear: function () {
        homeAv.num = '';
    },
    history: function () {
        homeView.router.loadPage('view/history.html');
    }
});

function disconnectDevice(peripheral) {
    Dxsdk.sys.stopNotify(peripheral, function () {
        Dxsdk.sys.disconnect(peripheral.id);
    });
}

F7.onPageBeforeInit('print', function (page) {

    var bill_number = page.query.bill_number;
    var bill_key = page.query.bill_key;
    var homeAvNum = page.query.deviceId;

    //bill_number 不为空时,是从历史记录页面进来的,直接从本地数据库取数据
    if (bill_number) {
        db.transaction(function (tx) {
            tx.executeSql('SELECT * FROM DATAS WHERE  bill_number = ?', [bill_number], function (tx, r) {
                var data = r.rows.item(0);
                //alert(JSON.stringify(data));
                //printAv.data = data;
                for (var i in data) {
                    for (var j in printAv) {
                        if (i == j) {
                            printAv[j] = data[i];
                        }
                    }
                }
            }, null);
        }, function (e) {
            console.log(e.message);
        });
    } else {
        //从首页进来的
        var data = homeAv.data;
        var base64 = homeAv.base64;
        var cfgData = homeAv.cfgData;
        var tempData = homeAv.tempData;
        var device_id = homeAvNum;
        var interval = cfgData.logInterval || data.interval;
        var total = tempData.num || data.total;
        var tmax = data.tmax;
        var tmin = data.tmin;
        var start_time = data.starttime;
        var end_time = data.endtime;
        var temp = tempData.temp ? tempData.temp.toFixed(1) : '';
        var content = cfgData.content;
        var param = data.param ? data.param : cfgData.highThreshold + '|' + cfgData.lowThreshold + '|' + cfgData.highToleranceTime + '|' + cfgData.lowToleranceTime;
    }
    var printAv = avalon.define({
        $id: "printCtl",
        bill_number: '',
        bill_key: '',
        device_id: device_id,
        interval: interval,
        total: total,
        max_t: tmax,
        min_t: tmin,
        start_time: start_time,
        end_time: end_time,
        mail: localStorage['mail'] ? localStorage['mail'] : '',
        datas: base64,
        temp: temp,
        uuid: '',
        device_name: '',
        model: '',
        status: status ? status : 0,
        content: content ? content : '',
        param: param,
        fixTime: function (v) {
            if (v) {
                return App.formatDate(v * 1000);
            } else {
                return "最近没有上传数据";
            }
        },
        save: function () {

            //邮箱正则 较粗略
            var mailReg = /^[\w!#$%&'*+/=?^_`{|}~-]+(?:\.[\w!#$%&'*+/=?^_`{|}~-]+)*@(?:[\w](?:[\w-]*[\w])?\.)+[\w](?:[\w-]*[\w])?$/;
            var at = Date.parse(new Date()) / 1000;
            var printAvMail = printAv.mail;
            if (printAvMail == '' || printAvMail == null || mailReg.test(printAvMail)) {
                App.confirm(printAvMail ? printAvMail : "未填写", '请确认邮箱地址：', function () {
                    localStorage['mail'] = printAvMail;
                    if (bill_number && bill_number.length == 12) {
                        postData();
                    } else if (bill_number && bill_number.length == 13) {
                        getBillNumber();
                        function getBillNumber() {
                            App.preloader.show('正在获取单据编号');
                            Service.getBillNumber(function (billObj) {
                                App.preloader.hide();
                                var bill_number = billObj.billnumber;
                                var bill_key = billObj.querycode;
                                printAv.bill_number = bill_number;
                                printAv.bill_key = bill_key;
                                var uuid = printAv.uuid;

                                db.transaction(function (tx) {
                                    tx.executeSql('UPDATE DATAS SET bill_number = ?, bill_key = ? WHERE uuid = ?', [bill_number, bill_key, uuid]);
                                }, function (e) {
                                    console.log(e.message);
                                });
                                postData();
                            }, function () {
                                App.preloader.hide();
                                App.confirm('发送报告失败,是否重试?', function () {
                                    getBillNumber();
                                })
                            })
                        }

                    } else {
                        getBillNum();
                        function getBillNum() {
                            App.preloader.show('正在获取单据编号');
                            Service.getBillNumber(function (billObj) {
                                App.preloader.hide();
                                var bill_number = billObj.billnumber;
                                var bill_key = billObj.querycode;

                                db.transaction(function (tx) {
                                    tx.executeSql('INSERT INTO DATAS (bill_number, bill_key, device_id, interval, total, max_t, min_t, start_time, end_time, mail, datas, uuid, device_name, model, param, status, bill_time) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', [bill_number, bill_key, printAv.device_id, printAv.interval, printAv.total, printAv.max_t, printAv.min_t, printAv.start_time, printAv.end_time, printAvMail, printAv.datas, data.uuid, data.name, data.model, printAv.param, printAv.status, at], function () {
                                        homeAv.showHistory = true;
                                    });
                                }, function (e) {
                                    console.log(e.message);
                                });

                                var postData = {
                                    uuid: data.uuid,
                                    device_id: device_id,
                                    device_name: data.name,
                                    model: data.model,
                                    billnumber: bill_number,
                                    starttime: start_time,
                                    endtime: end_time,
                                    interval: interval,
                                    datas: base64,
                                    record: {
                                        at: at,
                                        loc: loc,
                                        content: printAv.content
                                    },
                                    param: printAv.param,
                                    phoneuuid: device_uuid,
                                    email: printAvMail
                                };
                                postHistoryData(device_id, postData, bill_number, bill_key);


                            }, function () {
                                App.preloader.hide();
                                App.confirm('生成本地报告后,您可以在历史记录页面重新发送', '发送报告失败,是否重试?', function () {
                                    getBillNum();
                                }, function () {
                                    //无网络情况,生成一个假的单据编号
                                    var bill_number = String(at * 1000);
                                    var bill_key = '暂无';

                                    db.transaction(function (tx) {
                                        tx.executeSql('INSERT INTO DATAS (bill_number, bill_key, device_id, interval, total, max_t, min_t, start_time, end_time, mail, datas, uuid, device_name, model, param, status, bill_time) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', [bill_number, bill_key, printAv.device_id, printAv.interval, printAv.total, printAv.max_t, printAv.min_t, printAv.start_time, printAv.end_time, printAvMail, printAv.datas, data.uuid, data.name, data.model, printAv.param, printAv.status, at], function () {
                                            homeAv.showHistory = true;
                                            homeView.router.back();
                                        });
                                    }, function (e) {
                                        console.log(e.message);
                                    });
                                }, '生成本地报告', '重试')
                            });
                        }
                    }
                    function postData() {
                        var postData = {
                            uuid: printAv.uuid,
                            device_id: printAv.device_id,
                            device_name: printAv.device_name,
                            model: printAv.model,
                            billnumber: printAv.bill_number,
                            starttime: printAv.start_time,
                            endtime: printAv.end_time,
                            interval: printAv.interval,
                            datas: printAv.datas,
                            record: {
                                at: at,
                                loc: loc,
                                content: printAv.content
                            },
                            param: printAv.param,
                            phoneuuid: device_uuid,
                            email: printAvMail
                        };

                        postHistoryData(printAv.device_id, postData, printAv.bill_number, printAv.bill_key);
                    }
                });
            } else {
                App.alert('邮箱格式有误,请重新输入', function () {
                    $$('.weui_input').focus();
                });
            }
        }
    });
    avalon.scan();
    function postHistoryData(device_id, postData, bill_number, bill_key) {
        var device_id = device_id;
        var postData = postData;

        App.preloader.show('正在发送报告...');

        Service.postHistoryData(device_id, postData, function (ret) {
            App.preloader.hide();
            if (ret.code != 200 && ret.code != 212) {
                errorPost();
            } else {
                printAv.status = 1;
                db.transaction(function (tx) {
                    tx.executeSql('UPDATE DATAS SET status = 1 WHERE bill_number = ?', [bill_number]);
                }, function (e) {
                    console.log("ERROR: " + e.message);
                });
                homeView.router.loadPage('view/success.html?bill_number=' + bill_number + '&bill_key=' + bill_key);
            }
            // 服务器未响应或其他错误
        }, function () {
            errorPost();
        });

        function errorPost() {
            App.confirm('报告发送失败，是否重试？', function () {
                postHistoryData(device_id, postData, bill_number, bill_key);
            }, function () {
                homeView.router.back();
                App.alert('报告发送已取消,您可以在历史记录页面重新发送');
            });
        }
    }
});

F7.onPageBeforeInit('history', function () {
    var historyAv = avalon.define({
        $id: "historyCtl",
        data: []
    });

    var data = [];
    db.transaction(function (tx) {
        tx.executeSql('SELECT bill_number, bill_key, bill_time, status FROM DATAS ORDER BY bill_number DESC ', [], function (tx, r) {
            var rowsLength = r.rows.length;
            if (rowsLength > 0) {
                for (var i = 0; i < rowsLength; i++) {
                    data.push(r.rows.item(i));
                }
            }
            // 历史记录按生成时间排序 将时间戳转换成时间
            if (data.length > 0) {
                data.sort(function (a, b) {
                    return parseInt(b.bill_time) - parseInt(a.bill_time)
                });
                for (var j = 0; j < data.length; j++) {
                    data[j].bill_time = App.formatDate(data[j].bill_time * 1000, 2);
                }
                historyAv.data = data;
            }
        });
    }, function (e) {
        console.log("ERROR: " + e.message);
    });

    avalon.scan();
});

F7.onPageBeforeInit('success', function (page) {
    var bill_number = page.query.bill_number;
    var bill_key = page.query.bill_key;

    var successAv = avalon.define({
        $id: "successCtl",
        bill_number: bill_number,
        bill_key: bill_key,
        confirm: function () {
            homeView.router.load({pageName: 'index'})
        }
    });
    avalon.scan();
});