var Service = {};
App.url = "http://accp.duoxieyun.com/v1/";
App.openapiUrl = "http://api.duoxieyun.com/v2"; //http://api.duoxieyun.com/v2 http://yyq.tunnel.giter.org/v2

// 检查更新
Service.update = function (callback) {
    $$.ajax({
        url: "http://firmware.duoxieyun.com/sw/android/lenglianzhushou",
        method: "get",
        dataType: "json",
        success: function (ret) {
            callback(ret);
        }
    });
};

// 获取设备详情数据
Service.getDeviceInfo = function (id, callback, errorCallback) {
    App.http({
        api: "device/info/" + id,
        method: "GET"
    }, function (ret) {
        callback && callback(ret);
    }, function (ret) {
        errorCallback && errorCallback(ret);
    });
};

// 获取绑定设备详情数据
Service.getBindDeviceInfo = function (id, startTime, callback, errorCallback) {
    App.http({
        url: App.openapiUrl + "/app/device/bind/latestinfo/" + id,
        method: "GET",
        headers: {
            "Time-Start": startTime
        }
    }, function (ret) {
        callback && callback(ret);
    }, function (ret) {
        errorCallback && errorCallback(ret);
    });
};

// 获取数据单号
Service.getBillNumber = function (callback, errorCallback) {
    App.http({
        api: "system/billnumber",
        method: "GET"
    }, function (ret) {
        if(ret.code && ret.code != 200) {
            errorCallback && errorCallback();
        } else {
            callback && callback(ret);
        }
    }, function () {
        errorCallback && errorCallback();
    });
};

// 上传历史数据
Service.postHistoryData = function (id, data,callback, errorCallback) {
    var str = JSON.stringify(data);

    App.http({
        api: "device/historydata/" + id,
        method: "POST",
        params: str
    }, function (ret) {
        callback && callback(ret);
    }, function () {
        errorCallback && errorCallback();
    });
};

// 查询药品最后一次绑定的信息
Service.getLatestBind = function (code, callback, errorCallback) {
    App.http({
        url: App.openapiUrl + "/app/device/bind/latest/" + code,
        method: "GET"
    }, function (ret) {
        if(ret.code && ret.code != 200) {
            errorCallback && errorCallback();
        } else {
            callback && callback(ret);
        }
    }, function () {
        errorCallback && errorCallback();
    });
};